@ECHO off
CLS
SETlocal
REM ##########################################
REM Elevation PowerToy for Domain Administrators
REM BLOG: http://ivan.dretvich.com
REM ##########################################
ECHO.
ECHO =============================================================
ECHO "Elevate Command" PowerToy for Domain Administrators
ECHO =============================================================
ECHO. 
ECHO Purpose:   To add a command line method of launching applications that
ECHO            prompt for elevation (run as Administrator) to Windows
ECHO            XP, Vista and Windows 7.
ECHO. 
ECHO Refer to ElevateAsMe.inf for more details.
ECHO.
ECHO =============================================================
ECHO.
pause
cls

:myUser
REM This section specifies your administrative user name
ECHO. 
ECHO.
ECHO QUESTION: Please specify the administrative user account:
ECHO.
ECHO --------------------------------------------------------------
ECHO DESCRIPTION: You need to specify the user account that has  
ECHO administrative rights. Generally this is either your domain
ECHO admin account or an account with higher access.
ECHO. 
ECHO NOTE: Please just enter the name. No spaces, slashes or domain
ECHO info should be included. EG. test.admin
ECHO --------------------------------------------------------------
ECHO. 
ECHO QUESTION: Please specify the administrative user account:
ECHO.
SET /p myUser=
IF "%myUser%"=="" GOTO myUser
CLS

:myDomain
REM This section specifies your Active Directory Domain
ECHO. 
ECHO.
ECHO QUESTION: Please specify the AD Domain:
ECHO.
ECHO --------------------------------------------------------------
ECHO DESCRIPTION: You need to specify the AD domain name in which the 
ECHO user account belongs to.
ECHO. 
ECHO NOTE: Please just enter the fully qualified domain name. No spaces,
ECHO slashes or user info should be included. 
ECHO EG. domain.local
ECHO --------------------------------------------------------------
ECHO. 
ECHO QUESTION: Please specify the AD Domain:
ECHO.
SET /p myDomain=
IF "%myDomain%"=="" GOTO myDomain
CLS

REM This section specifies your OS
ECHO. 
ECHO.
ECHO QUESTION: Please specify the OS (XP or 7):
ECHO.
ECHO --------------------------------------------------------------
ECHO DESCRIPTION: You need to specify your OS so that the correct 
ECHO settings are installed. You have the following choices:
ECHO. 
ECHO              XP    -    This is for Windows XP
ECHO               7    -    This is for Windows 7
ECHO --------------------------------------------------------------
ECHO. 
ECHO QUESTION: Please specify the OS (XP or 7):
ECHO.
SET /p OS=
CLS

IF "%OS%"=="XP" GOTO XPprompt
IF "%OS%"=="xp" (GOTO XPprompt) ELSE (GOTO Confirm)
:XPprompt
REM This section confirms that you are a local admin.
ECHO. 
ECHO.
ECHO QUESTION: Are you you a LOCAL ADMINISTRATOR?:
ECHO.
ECHO --------------------------------------------------------------
ECHO DESCRIPTION: You need to be a LOCAL ADMINISTRATOR to install this 
ECHO on Windows XP. If you are not, you will need to log off and log back
ECHO on as a DOMAIN ADMINISTRATOR.
ECHO --------------------------------------------------------------
ECHO. 
ECHO If you are a Local administrator, please press any key otherwise
ECHO exit this window.
PAUSE
CLS

:Confirm
REM This section displays what will be done.
ECHO. 
ECHO.
ECHO --------------------------------------------------------------
ECHO The following settings will be applied to your install.
ECHO.
ECHO   User Name:         %myUser%
ECHO   Domain Name:       %myDomain%
ECHO   Operating System:  Windows %OS%
ECHO.
ECHO If any of the details above are wrong please exit this window
ECHO and rerun install.bat
ECHO If you want to remove this program, go to Add/Remove programs and
ECHO remove the program called "ElevateAsMe (%myUser%)"
ECHO --------------------------------------------------------------
ECHO. 
ECHO.
PAUSE
CLS

REM This section writes the user account info to ElevateAsMe.inf file (which is in the TEMP directory)
REM It will not modify the original install file.
copy *.* %temp%
ECHO myDomain="%myDomain%" >> %temp%\ElevateAsMe.inf
ECHO myUser="%myUser%" >> %temp%\ElevateAsMe.inf

IF "%OS%"=="XP" GOTO OS-XP 
IF "%OS%"=="xp" (GOTO OS-XP) ELSE (GOTO OS-7)
:OS-XP
rundll32.exe advpack.dll,LaunchINFSectionEx %temp%\ElevateAsMe.inf,ElevateAsMeXP,,32
GOTO END
:OS-7
rundll32.exe advpack.dll,LaunchINFSectionEx %temp%\ElevateAsMe.inf,ElevateAsMe7,,32

:END